SystemOrganization addCategory: #'Khami-Test-Core'!
SystemOrganization addCategory: #'Khami-Test-Core-Support'!
SystemOrganization addCategory: #'Khami-Test-Web'!

TestCase subclass: #KmDirectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Test-Core'!

!KmDirectionTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:17'!
testOppositeBottom
	self assert: Top equals: Bottom opposite! !

!KmDirectionTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:17'!
testOppositeLeft
	self assert: Right equals: Left opposite! !

!KmDirectionTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:17'!
testOppositeRight
	self assert: Left equals: Right opposite! !

!KmDirectionTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:16'!
testOppositeTop
	self assert: Bottom equals: Top opposite! !

TestCase subclass: #KmGameTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Test-Core'!

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/16/2011 20:17'!
testCurrentTileStartsBlank
	 | game |
	game := KmGame testGame.
	self assert: nil equals: game currentTile.! !

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 13:26'!
testPlaceTile
	| game gameBoard tile | 
	game := KmGame testGame.
	gameBoard := game board.
	tile := game takeTile.
	game placeTileAt: 3 at: 2.
	self assert: tile equals: (gameBoard at: 3 at: 2)! !

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 10:50'!
testPlaceTileClearsCurrentTile
	| game gameBoard tile | 
	game := KmGame testGame.
	gameBoard := game board.
	tile := game takeTile.
	game placeTileAt: 1 at: 2.
	self assert: nil equals: game currentTile! !

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2011 00:34'!
testPlaceTileWontReplaceExistingTile
	| game gameBoard tile | 
	game := KmGame testGame.
	gameBoard := game board.
	tile := game takeTile.
	game placeTileAt: 3 at: 2.
	game placeTileAt: 3 at: 2.
	self assert: tile equals: (gameBoard at: 3 at:2)
! !

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/16/2011 17:05'!
testTakeTile
	| game tile |
	game := KmGame testGame.
	tile := game remainingTiles last.
	self assert: tile equals: game takeTile! !

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/16/2011 16:57'!
testTakeTileRemovesItFromRemaining
	| game tile |
	game := KmGame testGame.
	tile := game takeTile.
	self deny: (game remainingTiles includes: tile).! !

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/16/2011 20:19'!
testTakeTileSetsCurrentTile
	| game tile |
	game := KmGame testGame.
	tile := game takeTile.
	self assert: tile equals: game currentTile.! !

!KmGameTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/21/2011 13:26'!
testTakeTileTwiceDoesntTakeAdditionalTile
	| game tile |
	game := KmGame testGame.
	tile := game takeTile.
	self assert: tile equals: game takeTile! !

TestCase subclass: #KmTestGameBoard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Test-Core'!

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2011 19:27'!
testCanPlaceTile
	| board |
	board := KmGameBoard new.
	self assert: (board canPlaceTile: KmTile new at: 3 at: 2) ! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2011 18:13'!
testCantPlaceTileBecauseAlreadyOccupied
	| board |
	board := KmGameBoard new.
	self deny: (board canPlaceTile: KmTile new at: 2 at: 2) ! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2011 18:12'!
testCantPlaceTileBecauseDoesntConnect
	| board |
	board := KmGameBoard new.
	self deny: (board canPlaceTile: KmTile new at: 1 at: 2) ! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2011 18:12'!
testCantPlaceTileBecauseNotAvailable
	| board |
	board := KmGameBoard new.
	self deny: (board canPlaceTile: KmTile new at: 1 at: 1) ! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:33'!
testInitialColumnsIs3
	self assert: 3 equals: KmGameBoard new columns.! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:34'!
testInitialRowsIs3
	self assert: 3 equals: KmGameBoard new rows.! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/16/2011 17:11'!
testPlaceTile
	 | gameBoard tile |
	gameBoard  := KmGameBoard new.
	tile := KmTile new.
	gameBoard at: 3 at: 2 put: tile.
	self assert: tile equals: (gameBoard at: 3 at: 2)! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:06'!
testPlaceTileAtBottomEdgeExtendsBoard
	 | gameBoard tile |
	gameBoard  := KmGameBoard new.
	tile := KmTile new.
	gameBoard at: 3 at: 2 put: tile.
	self assert: 4 equals: gameBoard rows.! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:06'!
testPlaceTileAtLeftEdgeExtendsBoard
	 | gameBoard tile |
	gameBoard  := KmGameBoard new.
	tile := KmTile new.
	gameBoard at: 2 at: 1 put: tile.
	self assert: 4 equals: gameBoard columns.! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:06'!
testPlaceTileAtLeftEdgeExtendsBoardAndRelocates
	 | gameBoard tile |
	gameBoard  := KmGameBoard new.
	tile := KmTile new.
	gameBoard at: 2 at: 1 put: tile.
	self assert: tile equals: (gameBoard at: 2 at: 2)! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:06'!
testPlaceTileAtRightEdgeExtendsBoard
	 | gameBoard tile |
	gameBoard  := KmGameBoard new.
	tile := KmTile new.
	gameBoard at: 3 at: 1 put: tile.
	self assert: 4 equals: gameBoard columns.! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:05'!
testPlaceTileAtTopEdgeExtendsBoard
	 | gameBoard tile |
	gameBoard  := KmGameBoard new.
	tile := KmTile new.
	gameBoard at: 1 at: 2 put: tile.
	self assert: 4 equals: gameBoard rows.! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:04'!
testPlaceTileAtTopEdgeExtendsBoardAndRelocates
	 | gameBoard tile |
	gameBoard  := KmGameBoard new.
	tile := KmTile new.
	gameBoard at: 1 at: 2 put: tile.
	self assert: tile equals: (gameBoard at: 2 at: 2)! !

!KmTestGameBoard methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:47'!
testStartingTileAtCentre
	| board |
	board := KmGameBoard new.
	self assert: board startingTile equals: (board at: 2 at: 2)! !

TestCase subclass: #KmTestGrid
	instanceVariableNames: 'fiveBySeven'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Test-Core-Support'!

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 19:54'!
setUp
	fiveBySeven := KmGrid ofSize: 5 by: 7.
	(1 to: 5) do: [ :row |
		(1 to: 7) do: [ : column | fiveBySeven at: row at: column put: row displayString, 'x', column displayString]] ! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:22'!
testAddColumn
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	grid addColumn.
	self assert: 8 equals: grid columns.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testAddColumns
	| grid |
	grid := KmGrid new.
	grid addColumns: 7.
	self assert: 7 equals: grid columns.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:21'!
testAddRow
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	grid addRow.
	self assert: 6 equals: grid rows.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testAddRows
	| grid |
	grid := KmGrid new.
	grid addRows: 5.
	self assert: 5 equals: grid rows.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 19:57'!
testAdjacentItems
	self assert: ({'1x2'. '2x3'. '3x2'. '2x1' } hasEqualElements: (fiveBySeven adjacentItemsAt: 2 at: 2))! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testEmptyGridColumns
	self assert: 0 equals: KmGrid new columns ! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testEmptyGridRows
	self assert: 0 equals: KmGrid new rows! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testInitialDataIsNil
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	self assert: nil equals: (grid at: 3 at: 4)! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testInitialSizeColumns
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	self assert: 7 equals: grid columns.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testInitialSizeRows
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	self assert: 5 equals: grid rows.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:17'!
testPrependColumn
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	grid prependColumn.
	self assert: 8 equals: grid columns.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:14'!
testPrependColumnMovesItems
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	grid at: 2 at: 2 put: 'foo'.
	grid prependColumn.
	self assert: nil equals: (grid at: 2 at: 2).
	self assert: 'foo' equals: (grid at: 2 at: 3).! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:16'!
testPrependRow
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	grid prependRow.
	self assert: 6 equals: grid rows.! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 11:16'!
testPrependRowMovesItems
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	grid at: 2 at: 2 put: 'foo'.
	grid prependRow.
	self assert: nil equals: (grid at: 2 at: 2).
	self assert: 'foo' equals: (grid at: 3 at: 2).! !

!KmTestGrid methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 12:35'!
testPutAndRetrieve
	| grid |
	grid := KmGrid ofSize: 5 by: 7.
	grid at: 3 at: 4 put: 'foo'.
	self assert: 'foo' equals: (grid at: 3 at: 4)! !

TestCase subclass: #KmTileSegmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Test-Core'!

!KmTileSegmentTest methodsFor: 'tests' stamp: 'StuartHerring 1/8/2011 22:53'!
testFarmRegionFromCode
	self assert: (KmTileSegment fromChar: $F) isFarm! !

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:44'!
testRoadConnectsToRoad
	self assert: (KmRoadPath new connectsTo:  KmRoadPath new)! !

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/28/2011 20:46'!
testRoadDoesntConnectToTerminator
	self deny: (KmRoadPath new connectsTo:  KmFarmRegion new)! !

!KmTileSegmentTest methodsFor: 'tests' stamp: 'StuartHerring 1/8/2011 22:54'!
testRoadPathFromCode
	self assert: (KmTileSegment fromChar: $-) isRoad! !

!KmTileSegmentTest methodsFor: 'tests' stamp: 'StuartHerring 1/8/2011 22:54'!
testUnknownCodeThrowsError
	self should: [ KmTileSegment fromChar: $z ] raise: Error! !

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:45'!
testVillageConnectsToVillage
	self assert: (KmVillageRegion new connectsTo:  KmVillageRegion new)! !

!KmTileSegmentTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 17:46'!
testVillageDoesntConnectToFarm
	self deny: (KmVillageRegion new connectsTo:  KmFarmRegion new)! !

!KmTileSegmentTest methodsFor: 'tests' stamp: 'StuartHerring 1/8/2011 22:53'!
testVillageRegionFromCode
	self assert: (KmTileSegment fromChar: $V) isVillage! !

TestCase subclass: #KmTileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Test-Core'!

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/28/2011 20:33'!
assertMappings: aCollection for: aTile
	self assert: (aCollection allSatisfy: [ :assoc | self verify: assoc key isNumber: assoc value inTile: aTile ]).! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 16:23'!
testAllowsTile
	| tile1 |
	tile1 := KmTile startingTile.
	self assert: (tile1 allowsTile: KmTile new at: Bottom)! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 16:24'!
testAllowsTileReturnsFalse
	| tile1 |
	tile1 := KmTile startingTile.
	self deny: (tile1 allowsTile: KmTile new at: Top)! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 18:08'!
testAllowsTileReturnsFalseDueToPaths
	| tile1 |
	tile1 := KmTile startingTile.
	self deny: (tile1 allowsTile: KmTile new at: Right)! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 16:27'!
testAllowsTileReturnsFalseWhenAlreadyOccupied
	| tile1 |
	tile1 := KmTile startingTile.
	tile1 tileAt: Bottom put: KmTile new.
	self deny: (tile1 allowsTile: KmTile new at: Bottom)! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/28/2011 20:48'!
testBuildFromString
	| tile |
	tile := KmTile fromString: 'VFVFF-F--'.
	self assert: (tile at: TopLeft) isVillage.
	self assert: (tile at: TopRight) isVillage.
	self assert: (tile at: RightTop) isFarm.
	self assert: (tile at: RightBottom) isFarm.
	self assert: (tile at: BottomRight) isVillage.
	self assert: (tile at: BottomLeft) isVillage.
	self assert: (tile at: LeftBottom) isFarm.
	self assert: (tile at: LeftTop) isFarm.

	self assert: (tile at: Top) isFarm. 
	self assert: (tile at: Left) isRoad.
	self assert: (tile at: Bottom) isFarm.
	self assert: (tile at: Right) isRoad.
	self assert: (tile at: Centre) isRoad.! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/28/2011 20:50'!
testBuildTileSet
	| set |
	set := KmTile buildTileSet: {
		'FFFFFFFFF'.
		'FFFFFFFFF'.
		'FFFFFFFFF'.
	}.
	self assert: 3 equals: set size.! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/26/2011 15:40'!
testCantCollectNonExistentPath
	| tile |
	tile := KmTile new.
	self  assert: 0 equals: (tile collectPathAt: Top) size.! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/28/2011 20:50'!
testCollectCompletePathWithTwoTiles
	| tile1 tile2 path |
	tile1 := KmTile startingTile.
	tile2 := KmTile fromString: 'FFFFF-FFF'.
	tile1 tileAt: Left put: tile2.
	path := (tile1 collectPathAt: Left) .
	self assert: 2 equals: path size.
	self assert: tile2 equals: path last! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/26/2011 15:39'!
testCollectPath
	| tile |
	tile := KmTile startingTile.
	self assert: 1 equals: (tile collectPathAt: Left) size.
	self assert: ((tile collectPathAt: Left) includes: tile).! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/28/2011 20:32'!
testInitialPaths
	| tile |
	tile := KmTile new.
	self assertMappings: {
		Top -> 2.
		Right -> 5.
		Bottom -> 8.
		Left -> 11.
		Centre ->13 } for: tile.! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/28/2011 20:39'!
testInitialRegions
	| tile |
	tile := KmTile new.
	self assertMappings: {
		TopLeft -> 1. TopRight -> 3.
		RightTop -> 4. RightBottom -> 6.
		BottomRight -> 7. BottomLeft ->9.
		LeftBottom -> 10. LeftTop -> 12} for: tile.! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/17/2011 16:47'!
testNewTileHasNothingAdjacent
	 | tile |
	tile := KmTile new.
	self assert: nil equals: (tile tileAt: Top).
	self assert: nil equals: (tile tileAt: Right).
	self assert: nil equals: (tile tileAt: Bottom).
	self assert: nil equals: (tile tileAt: Left)! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:23'!
testPlaceTile
	 | t1 t2 |
	t1 := KmTile new.
	t2 := KmTile new.
	
	t1 tileAt: Top put: t2.
	self assert: t2 equals: (t1 tileAt: Top)
! !

!KmTileTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/12/2011 13:25'!
testPlaceTileSetsReciprocalTile
	 | t1 t2 |
	t1 := KmTile new.
	t2 := KmTile new.
	
	t1 tileAt: Top put: t2.
	self assert: t1 equals: (t2 tileAt: Bottom)
! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/28/2011 20:58'!
testRotatedPaths
	| tile |
	tile := KmTile new.
	tile rotate.
	self assertMappings: {
		Top -> 11.
		Right -> 2.
		Bottom -> 5.
		Left -> 8.
		Centre ->13 } for: tile.! !

!KmTileTest methodsFor: 'tests' stamp: 'StuartHerring 1/28/2011 20:56'!
testRotatedRegions
	| tile |
	tile := KmTile new.
	tile rotate.
	self assertMappings: {
		TopLeft -> 10. TopRight -> 12.
		RightTop -> 1. RightBottom -> 3.
		BottomRight -> 4. BottomLeft ->6.
		LeftBottom -> 7. LeftTop -> 9} for: tile.! !

!KmTileTest methodsFor: 'convenience' stamp: 'StuartHerring 1/28/2011 20:34'!
verify: aSymbol isNumber: aNumber inTile: aTile
	^((aTile instVarNamed: #regions) at: aNumber) = (aTile at: aSymbol)! !
